#!/bin/python3
import sys
from cauchi import cauchi
import numpy as np
import matplotlib.pyplot as plt

#print (len(sys.argv))
# lay cac tham so tu dong lenh
if (len(sys.argv)<5):
	print (" Goi ham bang lenh:")
	print ("             sys.argv[0] y0 t0 tN dt")
	print (" hoac lenh:")
	print ("             sys.argv[0] y0 t0 t1 t2 t3 .. tN")
	print (" Trong do: y0 la dieu kien ban dau tai thoi diem ban dau t0,")
	print ("           t0 la thoi diem ban dau t0")
	print ("           t1, t2, .. la thoi diem can tinh")
	print ("           tN la thoi diem cuoi can tinh")
	print ("           dt la buoc thoi gian - neu t0, t1, t2 .. la cach deu")
	print (" Chu y:    Neu y0 khong phai la so thi yo duoc tinh tu ham goc")
	exit(255)
elif (len(sys.argv)==5):  ## lay t tu dong lenh theo cach goi 1
	t0 = float(sys.argv[2])
	tN = float(sys.argv[3])
	dt = float(sys.argv[4])
	t  = np.linspace(t0,tN,int((tN-t0)/dt)+1)
	#print (int((tN-t0)/dt))
else: # lay t tu dong lenh theo cach goi 2
	t = np.zeros(len(sys.argv)-2)
	for i in range(2,len(sys.argv)):
		#print (i,t[i-2])
		t[i-2] = float(sys.argv[i])

# Khoi tao cac bien
y0 = np.zeros(t.shape)
dt = np.diff(t)
k0 = np.zeros(dt.shape)
k12 = np.zeros(dt.shape)
y12 = np.zeros(dt.shape)

# bien de ve
y = np.zeros(dt.shape)
yg = np.zeros(dt.shape)

# lay y0 tu dong lenh
try:
	y0[0] = np.float64(sys.argv[1])
except:
	k0[0], y0[0] = cauchi(0, t[0])
	print ("y|t=%f=%f" , t[0],y0[0])

# In tieu de bang
print (" Bang tinh phuong trinh Cauchi bang phuong phap Diem giua\n")

# khai bao ky tu de ve bang
vien_ngang='\u2500'

# Kiem tra do lon cua khoang ngiem de in bang cho phu hop
do_lon = 10

# In tieu de bang
do_lon+=2
print ("\u250c%s\u252c%s\u252c%s\u252c%s\u252c%s\u252c%s\u2510" % \
        (vien_ngang*(do_lon-5), vien_ngang*(do_lon-5), vien_ngang*(do_lon+1), vien_ngang*(do_lon+5), vien_ngang*(do_lon+7),vien_ngang*(do_lon+3)))
do_lon-=2
print ("\u2502",'t0'.center(do_lon-5, ' '),"\u2502","dt".center(do_lon-5, ' '),"\u2502","k0=f(y0,t0)".center(do_lon, ' '),"\u2502", \
        "y1/2=y0+dt/2*k0".center(do_lon+5, ' '),"\u2502","k1/2=f(y1/2,t1/2)".center(do_lon,' '),"\u2502","y1=y0+dt*k1/2".center(do_lon,' '),"\u2502")
do_lon+=2
print ("\u251c%s\u253c%s\u253c%s\u253c%s\u253c%s\u253c%s\u2524" % \
        (vien_ngang*(do_lon-5), vien_ngang*(do_lon-5), vien_ngang*(do_lon+1), vien_ngang*(do_lon+5), vien_ngang*(do_lon+7),vien_ngang*(do_lon+3)))
do_lon-=2

# Lap de tinh theo phuong phap diem giua
for i in range(len(t)-1):
	k0[i],y[i] = cauchi(y0[i],t[i])
	y12[i] = y0[i] + k0[i] * dt[i]/2
	k12[i],yg[i] = cauchi(y12[i],t[i]+dt[i]/2)
	y0[i+1] = y0[i] + k12[i]*dt[i]
	# In bang ket qua
	print ("\u2502",str(f"{t[i]:.2f}").center(do_lon-5, ' '),"\u2502",str(f"{dt[i]:.2f}").center(do_lon-5, ' '),"\u2502", \
                str(f"{k0[i]:.5f}").center(do_lon+1, ' '), "\u2502",str(f"{y12[i]:.5f}").center(do_lon+5, ' '),"\u2502", \
                str(f"{k12[i]:.5f}").center(do_lon+7, ' '),"\u2502",str(f"{y0[i+1]:.5f}").center(do_lon+3,' '),"\u2502")

# In vien duoi cua bang
do_lon+=2
print ("\u2514%s\u2534%s\u2534%s\u2534%s\u2534%s\u2534%s\u2518" % \
        (vien_ngang*(do_lon-5), vien_ngang*(do_lon-5), vien_ngang*(do_lon+1), vien_ngang*(do_lon+5), vien_ngang*(do_lon+7),vien_ngang*(do_lon+3)))


